from collections import deque, defaultdict


def find_guarded_warehouses(n, roads, guards):

    graph = defaultdict(list)
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)

    guarded = set()  #

    for p, h in guards:
        queue = deque([(p, 0)])
        visited = set()

        while queue:
            current_warehouse, distance = queue.popleft()


            if current_warehouse in visited:
                continue
            visited.add(current_warehouse)


            if distance <= h:
                guarded.add(current_warehouse)


                for neighbor in graph[current_warehouse]:
                    if neighbor not in visited:
                        queue.append((neighbor, distance + 1))

    return sorted(guarded)



n = 5
roads = [(1, 2), (2, 3), (3, 4), (4, 5)]
guards = [(1, 2), (3, 1)]

guarded_warehouses = find_guarded_warehouses(n, roads, guards)
print(guarded_warehouses)





